/***
 * Cecilia ADL Compiler
 * Copyright (C) 2007 INRIA
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: fractal@objectweb.org
 *
 * Author: Alessio Pace
 */

package org.objectweb.fractal.cecilia.adl.test;

import org.objectweb.fractal.adl.ADLException;

/**
 * @author Alessio Pace
 */
public class LifeCycleControllerTest extends CeciliaAdlTestCase {

  public void testLCWithoutCanonicalName() throws Exception {
    try {
      this.tryCompileADL("test.controllers.PrimitiveWithNonCanonicalNameForLC");
      fail("Should have thrown an " + ADLException.class);
    } catch (final ADLException e) {
      // OK, the expected exception is thrown
    }
  }

  public void testLCWithCanonicalName() throws Exception {
    this.compileAndRun("test.controllers.PrimitiveWithCanonicalNameForLC");
  }

  public void testClientLCCInterface() throws Exception {
    this.compileAndRun("test.controllers.ClientLCCInterface");
  }
}
