/***
 * Fractal Task Codegen Framework
 * Copyright (C) 2006-2007 STMicroelectronics
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: fractal@objectweb.org
 *
 * Author: Matthieu Leclercq
 */

package org.objectweb.fractal.task.codegen.lib;

import org.objectweb.fractal.task.codegen.api.FileProviderTask;
import org.objectweb.fractal.task.codegen.api.SourceFileProviderTask;
import org.objectweb.fractal.task.codegen.util.SourceFile;

/**
 * Abstract implementation of the {@link FileProviderTask} task interface.
 */
public abstract class AbstractSourceFileProviderTask
    extends
      AbstractRequireSourceCodeProviderTask implements SourceFileProviderTask {

  private SourceFile providedFile;

  protected AbstractSourceFileProviderTask() {
    super();
  }

  protected AbstractSourceFileProviderTask(final int order) {
    super(order);
  }

  protected void setResult(final SourceFile result) {
    providedFile = result;
  }

  // --------------------------------------------------------------------------
  // Implementation of the SourceFileProviderTask interface
  // --------------------------------------------------------------------------

  public SourceFile getSourceFile() {
    return providedFile;
  }

  // --------------------------------------------------------------------------
  // Implementation of the Task interface
  // --------------------------------------------------------------------------

  public Object getResult() {
    return getSourceFile();
  }
}
